/*
 *ʹ˫Ĵͨų
 * lstzixing -- Si Chuan University
 * Date:2008-7-27
 * QQ:527676163
 * Email:blievethink@gmail.com
 */

#include <AT89X52.H>

#define	OSC_FREQ		11059200				/* ƵʣHz*/
#define	FREQ_PER_CLK	12						/* ÿʱڶӦ */
#define	BAOUD_RATE		9600					/* ,bps */
#define	SMOD_BIT		0						/* SMOD,ʱλ,Ϊ1ʱ */

#define	OUT_TX_BUFF_LEN	4						/* ͻ */
#define	REC_RX_BUFF_LEN	5						/* ջ */

#define	SERIAL_INT_VECTOR	4					/* ж */
#define	SERIAL_INT_REG	1						/* жõļĴ */


/*
 * TxNextPtr --- ָӦóҪдһпռ
 * TxCurrPtr --- ָǰֽ
 * TxFreeCount --  ǰռֽ
 * SendFlag --- ǷҪֶж
 */
unsigned char *TxNextPtr, *TxCurrPtr, TxFreeCount;
bit	SendFlag;
unsigned char data OutTxBuff[ OUT_TX_BUFF_LEN ];	/* ͻ */

/*
 * RecNextPtr --- ָһڽⲿ͵ֽݿռ
 * RecCurrPptr -- ָӦóȡݵַ
 * RecCout	   -- ջдȡߵֽڼ
 */
unsigned char data RecRxBuff[ REC_RX_BUFF_LEN ];
unsigned char *RecNextPtr, *RecCurrPtr, RecCount;

/* ***************************************************************
 *					ڳʼ--SerialInit()
 * ܣÿڴڵĹʽʣݸʽʼ
 *        ݽṹжϣʱ1뿪
 * ˵ͨʹT1Ϊʷ
 * ************************************************************** */
void	SerialInit()
{
#if	SMOD_BIT									/* ʼ*/
	TH1 = TL1 = 256 - 2*OSC_FREQ/(32*FREQ_PER_CLK*BAOUD_RATE);
	PCON |= 0x80;
#else 
	TH1 = TL1 = 256 - (long)OSC_FREQ/(32*FREQ_PER_CLK*(long)BAOUD_RATE);
	PCON &= 0x80;
#endif

	SCON = 0x50;								/* ʽ18λ첽շżУ */
	TMOD &= 0xF;								/* 8λԶװʱ */
	TMOD |= 0x20;	

	TxNextPtr = TxCurrPtr = OutTxBuff;			/* ݽṹʼ */
	TxFreeCount = OUT_TX_BUFF_LEN;
	SendFlag = 1;								/* Ҫֶж */

	RecNextPtr = RecCurrPtr = RecRxBuff;
	RecCount = 0;

	ES = 1;										/* жϺͼʱ */
	TR1 = 1;	

}

/* *************************************************************
 *						---RecRxStr()
 * ܣӴڽճΪlenֽڵݣstrΪַĿռ.
 * : str ---- ݴŻַ
 *       len ---- Ҫյ
 * ˵lenֵڽջȴֱյ
 *       ݡ
 * ************************************************************ */
void	RecRxStr( char *str, unsigned char len )
{
	while(!RecCount);							/* ѽյΪգѭȴ */
	while( len-- )
	{
		while(!RecCount );						/* Ҫȡݣѭȴ */
		*str++ = *RecCurrPtr++;
		RecCount--;
		if( RecCurrPtr == RecRxBuff+REC_RX_BUFF_LEN )
		{
			RecCurrPtr = RecRxBuff;
		}
	}
}

/* ****************************************************************
 *			򴮿ڷ -- OutTxStr()
 *ܣstrΪַĿռУȡlenݣͨڷ
 *str --- ݵʼַ
 *		len --- ݳ
 *˵lenڷͻ峤ͻһӳ
 * ************************************************************** */
void	OutTxStr( char *str, unsigned char len  )
{
	while(!TxFreeCount);								/* ʣռ䣬ȴ */
    SendFlag = (TxFreeCount<OUT_TX_BUFF_LEN)?0:1;		/* ݣ򲻱ֶж */

	while( len-- )
	{
		*TxNextPtr++ = *str++;
		TxFreeCount--;
		if( TxNextPtr == OutTxBuff+OUT_TX_BUFF_LEN )	/* ߽ʱ */
		{
			TxNextPtr = OutTxBuff;
		}

		if( !TxFreeCount )							/* ʣռ䣬ȴ */
		{ 
			if( SendFlag )	{ SendFlag = 0; TI = 1; }					/* ȷѼʹ*/
			while(!TxFreeCount);					/* ѭȴ */
		}
	}

	if( SendFlag )   TI	= 1;										/* еַд */
}

/* **************************************************************
 *				ˢ ---- FlushQueue()
 * ܣöóʼ״̬
 * queue --- ˢµĶַΪOutTxBuff/ RecRxBuff
 * ˵ԭеݲ
 * ************************************************************* */
void 	FlushQueue( char * queue )
 {
 	if( queue == OutTxBuff )	
    {
		TxNextPtr = TxCurrPtr = OutTxBuff;
		TxFreeCount = OUT_TX_BUFF_LEN;
		SendFlag = 1;
	}
	else if( queue == RecRxBuff )
    {
		RecCount = 0;
		RecNextPtr = RecCurrPtr = RecRxBuff;
	}

 }
/* *************************************************************
 *					жϴ --- SerialISR()
 * ܣSBUFȡдջ
 *		ӷͻȡдSBUF
 *
 * ************************************************************* */
void	SerialISR()	interrupt	SERIAL_INT_VECTOR	using	SERIAL_INT_REG
{
	if( TI )															/* ж */
	{
		if( TxFreeCount == OUT_TX_BUFF_LEN )	{ TI=0; return; }		/* Ϊʱ */

		SBUF = *TxCurrPtr++;											/* ַ */		
		if( TxCurrPtr==OutTxBuff+OUT_TX_BUFF_LEN )	TxCurrPtr = OutTxBuff;/* ػ*/
		TxFreeCount++;	
		TI = 0;				
	}
	else
	{
		if( RecCount == REC_RX_BUFF_LEN )	return;						/* */
		*RecNextPtr++ = SBUF;
		if( RecNextPtr == RecRxBuff+REC_RX_BUFF_LEN )	RecNextPtr = RecRxBuff;
		RecCount++;
		RI = 0;
	}
}


int	main()
{
char str[20];

	EA = 1;

	SerialInit();
	while(1)	
	{
	//	RecRxStr( str, 8 );
	//	OutTxStr( str, 8 );
		RecRxStr( str, 1 );
		OutTxStr( str, 1 );

	}
}
